import { select, 
         range,
         scaleOrdinal,
         scaleLinear,
        } 
from 'd3';

export const legends = (selection ,properties)=> {
   const data  = properties.data;
   const axis = properties.axis;
  
   const p = properties.padding;
   const c = properties.data.domain().length;
  
   const height = selection.attr('height');
   const width = selection.attr('width');
  
   
   let maxpo;
   let cross;
   
   if(axis == 'vertical'){
     maxpo = height;
     cross = width 
   }else{
     maxpo = width;
     cross = height;
   }
   const position = (i) => range(p+maxpo/6,maxpo-p,(maxpo-2*p)/c)[i];
  
   const legends = selection.selectAll('g').data(range(c));
  
   const legend = legends.enter().append('g');
   
   if(axis == 'vertical'){
     legend.attr('transform', d => `translate(${cross/4},${position(d)})`);
   }else{
     legend.attr('transform', d => `translate(${position(d)},${cross/4})`);
   }
  
   const color = (i) => data.range()[i];
  
   const label = (i) => data.domain()[i];
 
   legend.append('circle')
         .attr('r',maxpo/(4*c))
         .attr('style',d => `fill: ${color(d)}`)
  
   legend.append('text')
         .text(d => label(d))
         .attr('dx',cross/2.12)
         .attr('dy',maxpo/(4*c)/2)
         .attr('class','label')
   
}

