import { select, 
         range,
         scaleOrdinal,
         scaleLinear
        } 
from 'd3'; 

export function drawFruitsAnim(selection,data){
  
  const bowl = selection.selectAll('rect').data([0]).enter().append('rect');
  const fruits = data.fruits;
  const height = data.hpos;
  
  
  
  bowl.attr('height',170)
      .attr('width',600)
      .attr('x',180)
      .attr('y',height-110)
      .attr('rx',100)
  
  const getFruitSize =  scaleOrdinal().domain(["apple","lemon"]).range([60,30]);
  
  const getFruitPosition = scaleLinear().domain([0,25]).range([300,3200]);

  const groups =  selection.selectAll('g').data(fruits, d=> d.id);
  
  const group = groups.enter().append('g');
     
  group.attr('transform',(d,i) => `translate(${getFruitPosition(i)},${height})`)
           .merge(groups).transition().delay(2000)
           .attr('transform',(d,i) => `translate(${getFruitPosition(i)},${height})`);
  
  const removed_group = groups.exit().transition().delay(2000);
 
  group.append('circle')
            .attr('r',(d,i) => getFruitSize(d.type))
            .attr('class',(d,i) => d.type)
        .merge( groups.select('circle'))
            .transition().delay(1000)
            .attr('class',(d,i) => d.type) 
            .attr('r',(d,i) => getFruitSize(d.type))
  
  removed_group.select('circle').attr('r',0)
            .remove();
  
  group.append('text')
            .text((d,i) => d.type)
        .merge( groups.select('text')).transition().delay(1000)
             .text((d,i) => d.type)
  
  removed_group.select('text').remove();
  
}